<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from xml/schema/CRM/Mailing/Spool.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:3428809b9b08d641d615c79f93caafb3)
 */

/**
 * Database access object for the Spool entity.
 */
class CRM_Mailing_DAO_Spool extends CRM_Core_DAO {
  const EXT = 'civicrm';
  const TABLE_ADDED = '';
  const COMPONENT = 'CiviMail';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_mailing_spool';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = FALSE;

  /**
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $id;

  /**
   * The ID of the Job .
   *
   * @var int|string
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $job_id;

  /**
   * The email of the recipients this mail is to be sent.
   *
   * @var string|null
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $recipient_email;

  /**
   * The header information of this mailing .
   *
   * @var string|null
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $headers;

  /**
   * The body of this mailing.
   *
   * @var string|null
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $body;

  /**
   * date on which this job was added.
   *
   * @var string
   *   (SQL type: timestamp)
   *   Note that values will be retrieved from the database as a string.
   */
  public $added_at;

  /**
   * date on which this job was removed.
   *
   * @var string
   *   (SQL type: timestamp)
   *   Note that values will be retrieved from the database as a string.
   */
  public $removed_at;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_mailing_spool';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? ts('Spools') : ts('Spool');
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Spool ID'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_mailing_spool.id',
          'table_name' => 'civicrm_mailing_spool',
          'entity' => 'Spool',
          'bao' => 'CRM_Mailing_BAO_Spool',
          'localizable' => 0,
          'html' => [
            'type' => 'Number',
          ],
          'readonly' => TRUE,
          'add' => NULL,
        ],
        'job_id' => [
          'name' => 'job_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Job ID'),
          'description' => ts('The ID of the Job .'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_mailing_spool.job_id',
          'table_name' => 'civicrm_mailing_spool',
          'entity' => 'Spool',
          'bao' => 'CRM_Mailing_BAO_Spool',
          'localizable' => 0,
          'FKClassName' => 'CRM_Mailing_DAO_MailingJob',
          'FKColumnName' => 'id',
          'html' => [
            'label' => ts("Job"),
          ],
          'add' => NULL,
        ],
        'recipient_email' => [
          'name' => 'recipient_email',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => ts('Recipient Email'),
          'description' => ts('The email of the recipients this mail is to be sent.'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_mailing_spool.recipient_email',
          'table_name' => 'civicrm_mailing_spool',
          'entity' => 'Spool',
          'bao' => 'CRM_Mailing_BAO_Spool',
          'localizable' => 0,
          'add' => NULL,
        ],
        'headers' => [
          'name' => 'headers',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => ts('Headers'),
          'description' => ts('The header information of this mailing .'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_mailing_spool.headers',
          'table_name' => 'civicrm_mailing_spool',
          'entity' => 'Spool',
          'bao' => 'CRM_Mailing_BAO_Spool',
          'localizable' => 0,
          'add' => NULL,
        ],
        'body' => [
          'name' => 'body',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => ts('Body'),
          'description' => ts('The body of this mailing.'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_mailing_spool.body',
          'table_name' => 'civicrm_mailing_spool',
          'entity' => 'Spool',
          'bao' => 'CRM_Mailing_BAO_Spool',
          'localizable' => 0,
          'add' => NULL,
        ],
        'added_at' => [
          'name' => 'added_at',
          'type' => CRM_Utils_Type::T_TIMESTAMP,
          'title' => ts('Added'),
          'description' => ts('date on which this job was added.'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_mailing_spool.added_at',
          'default' => NULL,
          'table_name' => 'civicrm_mailing_spool',
          'entity' => 'Spool',
          'bao' => 'CRM_Mailing_BAO_Spool',
          'localizable' => 0,
          'add' => NULL,
        ],
        'removed_at' => [
          'name' => 'removed_at',
          'type' => CRM_Utils_Type::T_TIMESTAMP,
          'title' => ts('Removed'),
          'description' => ts('date on which this job was removed.'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_mailing_spool.removed_at',
          'default' => NULL,
          'table_name' => 'civicrm_mailing_spool',
          'entity' => 'Spool',
          'bao' => 'CRM_Mailing_BAO_Spool',
          'localizable' => 0,
          'add' => NULL,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'mailing_spool', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'mailing_spool', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
